'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isSchema = require('./util/isSchema');

var _isSchema2 = _interopRequireDefault(_isSchema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

class Lazy {
  constructor(mapFn) {
    this._resolve = (...args) => {
      const schema = mapFn(...args);
      if (!(0, _isSchema2.default)(schema)) {
        throw new TypeError('lazy() functions must return a valid schema');
      }

      return schema;
    };
  }

  resolve(_ref) {
    let { value } = _ref,
        rest = _objectWithoutProperties(_ref, ['value']);

    return this._resolve(value, rest);
  }

  cast(value, options) {
    return this._resolve(value, options).cast(value, options);
  }

  validate(value, options) {
    return this._resolve(value, options).validate(value, options);
  }
}

Lazy.prototype.__isYupSchema__ = true;

exports.default = Lazy;